/**
 * Data Flow API
 * Use the Data Flow APIs to run any Apache Spark application at any scale without deploying or managing any infrastructure.

 * OpenAPI spec version: 20200129
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2023, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A statement object.
 *
 */
export interface Statement {
    /**
     * The statement ID.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "id": number;
    /**
     * The statement code to execute.
     * Example: `println(sc.version)`
     *
     */
    "code": string;
    /**
     * The current state of this statement.
     *
     */
    "lifecycleState": model.StatementLifecycleState;
    "output"?: model.StatementOutput;
    /**
     * The execution progress.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "progress"?: number;
    /**
     * The ID of a run.
     *
     */
    "runId"?: string;
    /**
     * The date and time a application was created, expressed in [RFC 3339](https://tools.ietf.org/html/rfc3339) timestamp format.
     * Example: `2018-04-03T21:10:29.600Z`
     *
     */
    "timeCreated": Date;
    /**
     * The date and time a statement execution was completed, expressed in [RFC 3339](https://tools.ietf.org/html/rfc3339) timestamp format.
     * Example: `2022-05-31T21:10:29.600Z`
     *
     */
    "timeCompleted"?: Date;
}
export declare namespace Statement {
    function getJsonObj(obj: Statement): object;
    function getDeserializedJsonObj(obj: Statement): object;
}
